#
# Conditional build:
%bcond_without	tests		# build without tests

# TODO
# - PLDize (or drop) /etc/yum/version-groups.conf
%define	rpm_ver 5.4.10-50
Summary:	RPM installer/updater
Summary(pl.UTF-8):	Narzędzie do instalowania/uaktualniania pakietów RPM
Name:		yum
Version:	3.4.3
Release:	7
License:	GPL v2+
Group:		Applications/System
Source0:	http://yum.baseurl.org/download/3.4/%{name}-%{version}.tar.gz
# Source0-md5:	7c8ea8beba5b4e7fe0c215e4ebaa26ed
Source1:	%{name}-pld-source.repo
Source2:	%{name}-pld-ti-source.repo
# from util-vserver-*/contrib/
#Patch:		%{name}-chroot.patch # disabled for now. broken or not needed
Patch1:		%{name}-obsoletes.patch
Patch2:		cli-pyc.patch
Patch3:		%{name}-pld.patch
Patch4:		%{name}-amd64.patch
Patch5:		%{name}-config.patch
Patch6:		nosetests.patch
Patch7:		rpm5.patch
Patch8:		tests.patch
Patch9:		pld-release.patch
Patch10:	rpm5-%{name}.patch
Patch11:	rpm5-caps.patch
Patch12:	%{name}-missingok.patch
Patch13:	%{name}-info-no-size.patch
# fc
Patch100:	%{name}-HEAD.patch
# Patch100-md5:	e9eff22b1a68e83b271bdec261411648
Patch101:	installonlyn-enable.patch
Patch102:	%{name}-manpage-files.patch
Patch103:	no-more-exactarchlist.patch
Patch104:	%{name}-completion-helper.patch
Patch105:	%{name}-distro-configs.patch
URL:		http://yum.baseurl.org/
BuildRequires:	bash-completion >= 2.0
BuildRequires:	gettext-devel
BuildRequires:	intltool
BuildRequires:	python-rpm >= %{rpm_ver}
BuildRequires:	python-urlgrabber
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.228
BuildConflicts:	yum < 3.4.3-2.1
%if %{with tests}
BuildRequires:	python-nose
BuildRequires:	yum-metadata-parser
%if %(locale -a | grep -qFx en_US.utf8; echo $?)
BuildRequires:	glibc-localedb-all
%endif
%endif
Requires:	python >= 1:2.5
Requires:	python-iniparse
Requires:	python-libxml2
Requires:	python-pygpgme
Requires:	python-rpm >=  %{rpm_ver}
Requires:	rpm >= %{rpm_ver}
Requires:	python-sqlite
Requires:	python-urlgrabber >= 1:3.9.1
Requires:	rpm >= %{rpm_ver}
Requires:	yum-metadata-parser >= 1.1.4
Obsoletes:	yum-plugin-security < 1.1.32
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_libdir		%{_prefix}/lib

%description
Yum is a utility that can check for and automatically download and
install updated RPM packages. Dependencies are obtained and downloaded
automatically prompting the user as necessary.

%description -l pl.UTF-8
Yum to narzędzie sprawdzające i automatycznie ściągające i instalujące
uaktualnione pakiety RPM. Zależności są ściągane automatycznie po
zapytaniu użytkownika w razie potrzeby.

%package -n bash-completion-%{name}
Summary:	bash-completion for Yum
Group:		Applications/Shells
Requires:	%{name}
Requires:	bash-completion >= 2.0
Conflicts:	%{name} < 3.4.3-3

%description -n bash-completion-%{name}
bash-completion for Yum.

%prep
%setup -q
# fc
%patch100 -p1
%patch101 -p0
%patch102 -p1
%patch103 -p0
%patch104 -p1
%patch105 -p1
# pld
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1

%build
%{__make}

%if %{with tests}
# yum itself must work (tests does not cover import errors)
# we ignore exit code, as it will exit with error if yum is not installed:
# $ ./yummain.py --version
#3.4.3
#CRITICAL:yum.cli:Config Error: Error accessing file for config file:///etc/yum.conf
# and it will fail other ways if incompatible yum version is installed

ver=$(./yummain.py --version | head -n1)
test $ver = %{version}

# test/check-po-yes-no.py prints chinese to screen, need to enable utf8
export LC_ALL=en_US.utf8
%{__make} test \
	NOSETESTS=nosetests-%{py_ver}
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir}/yum/pluginconf.d,%{_libdir}/yum-plugins,%{_datadir}/yum-plugins}
%{__make} install \
	PYLIBDIR=%{py_scriptdir} \
	DESTDIR=$RPM_BUILD_ROOT

# no cron (unstable, and poldek is main pkg manager)
%{__rm} $RPM_BUILD_ROOT/etc/cron.daily/0yum-daily.cron
%{__rm} $RPM_BUILD_ROOT/etc/cron.hourly/0yum-hourly.cron
%{__rm} $RPM_BUILD_ROOT%{systemdunitdir}/yum-cron.service
%{__rm} $RPM_BUILD_ROOT%{_sysconfdir}/yum/yum-cron.conf
%{__rm} $RPM_BUILD_ROOT%{_sysconfdir}/yum/yum-cron-hourly.conf
%{__rm} $RPM_BUILD_ROOT%{_sbindir}/yum-cron
%{__rm} $RPM_BUILD_ROOT%{_mandir}/man8/yum-cron.8*

# for now, move repodir/yum.conf back
mv $RPM_BUILD_ROOT%{_sysconfdir}/{yum/repos.d,/yum.repos.d}
mv $RPM_BUILD_ROOT%{_sysconfdir}/{yum/yum.conf,yum.conf}

cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d/pld.repo

install -d $RPM_BUILD_ROOT/var/lib/yum/{history,plugins,yumdb}
# see yum.conf(5)
touch $RPM_BUILD_ROOT/var/lib/yum/uuid

%py_ocomp $RPM_BUILD_ROOT%{py_sitescriptdir} $RPM_BUILD_ROOT%{_datadir}/yum-cli
%py_comp $RPM_BUILD_ROOT%{py_sitescriptdir} $RPM_BUILD_ROOT%{_datadir}/yum-cli

%py_postclean %{_datadir}/yum-cli

mv $RPM_BUILD_ROOT%{_localedir}/lt{_LT,}
# duplicate with id, nl and pt
rm -r $RPM_BUILD_ROOT%{_localedir}/id_ID
rm -r $RPM_BUILD_ROOT%{_localedir}/nl_NL
rm -r $RPM_BUILD_ROOT%{_localedir}/pt_PT

%find_lang %{name}

# in yum-updatesd.spec
%{__rm} $RPM_BUILD_ROOT/etc/dbus-1/system.d/yum-updatesd.conf
%{__rm} $RPM_BUILD_ROOT/etc/rc.d/init.d/yum-updatesd
%{__rm} $RPM_BUILD_ROOT%{_sysconfdir}/yum/yum-updatesd.conf
%{__rm} $RPM_BUILD_ROOT%{_sbindir}/yum-updatesd
%{__rm} $RPM_BUILD_ROOT%{_mandir}/man5/yum-updatesd.conf.5*
%{__rm} $RPM_BUILD_ROOT%{_mandir}/man8/yum-updatesd.8*

%clean
rm -rf $RPM_BUILD_ROOT

%pretrans
# migrate to new dir. having two dirs is really confusing
if [ -d %{_sysconfdir}/yum/repos.d ]; then
	echo >&2 "Migrating %{_sysconfdir}/yum/repos.d to %{_sysconfdir}/yum.repos.d"
	mkdir -p %{_sysconfdir}/yum.repos.d
	for a in %{_sysconfdir}/yum/repos.d/*; do
		if [ -f "$a" ]; then
			mv -vf $a %{_sysconfdir}/yum.repos.d/${a##*/}
		fi
	done
	rm -rf %{_sysconfdir}/yum/repos.d
fi

%triggerpostun -- %{name} < 3.2.12-3
if [ -f %{_sysconfdir}/yum/repos.d/pld-source.repo.rpmsave ]; then
	cp -f %{_sysconfdir}/yum/repos.d/pld.repo{,.rpmnew}
	mv -f %{_sysconfdir}/yum/repos.d/{pld-source.repo.rpmsave,pld.repo}
fi

%files -f %{name}.lang
%defattr(644,root,root,755)
%doc README AUTHORS TODO INSTALL ChangeLog
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/logrotate.d/%{name}

# main yum config
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/yum.conf

%dir %{_sysconfdir}/yum
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/yum/version-groups.conf

%dir %{_sysconfdir}/yum.repos.d
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/yum.repos.d/*.repo

%dir %{_sysconfdir}/yum/pluginconf.d
%dir %{_sysconfdir}/yum/protected.d
%dir %{_sysconfdir}/yum/vars

%attr(755,root,root) %{_bindir}/yum

%dir %{py_sitescriptdir}/yum
%dir %{_datadir}/yum-cli
%{_datadir}/yum-cli/*.py[co]

%{py_sitescriptdir}/yum/*.py[co]
%dir %{py_sitescriptdir}/rpmUtils
%{py_sitescriptdir}/rpmUtils/*.py[co]

%dir %{_libdir}/yum-plugins
%dir %{_datadir}/yum-plugins

%{_mandir}/man5/yum.conf.5*
%{_mandir}/man8/yum-shell.8*
%{_mandir}/man8/yum.8*

%dir /var/cache/yum

%dir /var/lib/yum
%dir /var/lib/yum/history
%dir /var/lib/yum/plugins
%dir /var/lib/yum/yumdb
%ghost /var/lib/yum/uuid

%files -n bash-completion-%{name}
%defattr(644,root,root,755)
%{_datadir}/bash-completion/completions/yum
%{_datadir}/bash-completion/completions/yummain.py
%changelog
* Sun Apr 28 2013 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/yum.git;a=log;h=master

* Sun Apr 28 2013 Elan Ruusamäe <glen@delfi.ee> 83f456d
- drop Suggests packages from repodata output (_dump_requires)

* Sat Apr 27 2013 Elan Ruusamäe <glen@delfi.ee> 3899739
- yum-security plugin was moved into core.

* Sat Apr 27 2013 Elan Ruusamäe <glen@delfi.ee> ba91c95
- update yum-HEAD patch from fedora

* Sat Apr 27 2013 Elan Ruusamäe <glen@delfi.ee> 7bb2d2f
- fix "yum info FHS" throwing exception as the size is NULL

* Sat Apr 27 2013 Elan Ruusamäe <glen@delfi.ee> 992b68e
- restore yum-missingok.patch and make yum ignore all Suggests instead of giving error of unsatisfied deps

* Sat Apr 27 2013 Elan Ruusamäe <glen@delfi.ee> fa89d7c
- disable history recording

* Sat Apr 27 2013 Elan Ruusamäe <glen@delfi.ee> e663fd5
- update rpm deps

* Sat Apr 27 2013 Elan Ruusamäe <glen@delfi.ee> ef89ae1
- adjusted for current codebase, a lot simplier

* Sat Apr 27 2013 Elan Ruusamäe <glen@delfi.ee> 81607a8
- add missingok patch

* Sat Apr 27 2013 Elan Ruusamäe <glen@delfi.ee> 4b94531
- require rpm with rpm.RPMSENSE_MISSINGOK

* Sat Apr 27 2013 Elan Ruusamäe <glen@delfi.ee> 76d04f3
- Revert "- this is useless"

* Sat Apr 27 2013 Elan Ruusamäe <glen@delfi.ee> bec95d3
- ignore rpm5 uname and cpuinfo caps

* Sat Apr 27 2013 Elan Ruusamäe <glen@delfi.ee> 7881689
- renumber fedora patches

* Sat Apr 27 2013 Elan Ruusamäe <glen@delfi.ee> 8b8b918
- Merge patches from rpm5-yum project https://launchpad.net/yum

* Sat Apr 27 2013 Elan Ruusamäe <glen@delfi.ee> f4dfe87
- adjust rpm5-yum patch against current tree

* Sat Apr 27 2013 Elan Ruusamäe <glen@delfi.ee> 1ab9b70
- Picked patches from rpm5-yum project https://launchpad.net/yum

* Sun Apr 21 2013 Jan Rękorajski <baggins@pld-linux.org> 97eb011
- use NODSAHEADER in place of NOSIGNATURES|NODIGESTS for rpm5
- rel 4

* Mon Apr 15 2013 Elan Ruusamäe <glen@delfi.ee> 11e2cec
- split package conflict on unsplit version

* Mon Apr 15 2013 Elan Ruusamäe <glen@delfi.ee> 5ed5d73
- updated patches from fedora, including HEAD merge, bash-completions split

* Mon Apr 15 2013 Elan Ruusamäe <glen@delfi.ee> 40116bf
- split bash-completions package; rel 3

